library('MixMatrix')
library('abind')
### if(!require('RFASTfMRI')) devtools::install_github('ialmodovar/RFASTfMRI')
library('RFASTfMRI')
load('fMRI-slice.rda')

par(mfrow=c(1,2))
par(mar=c(0, 0, 0, 0))
image(sliceLH[,,1], axes= FALSE, col = gray(0:12/12))
image(sliceRH[,,1], axes = FALSE, col = gray(0:12/12))

rfastresults.LH = FASTfMRI(sliceLH[,,])

rfastresults.RH = FASTfMRI(sliceRH[,,])

actmapLH = (rowMeans(rfastresults.LH$ActMap, dims = 2))

actmapRH = (rowMeans(rfastresults.RH$ActMap, dims = 2))

par(mfrow = c(1,2), mar = c(0,0,0,0))
 image(actmapLH > .8)
image(actmapRH > .8)


png('differential-activation.png', height = 128, width = 256)
par(mfrow = c(1,2), mar = c(0,0,0,0))
image((actmapLH > .8)*(actmapRH < .8), axes = FALSE)
image((actmapLH < .8)*(actmapRH > .8), axes = FALSE)
dev.off()


meanmap = matrix(0,108,108)
for(i in 1:108){
    for(j in 1:108){
        meanmap[i,j] = mean(actmapLH[i:(i+20),j:(j+20)])
    }
}

image(meanmap)
lhmax = which.max(meanmap)
round(lhmax/108)+1
lhmax %% 108

### this was the one for 10, not 20
meanmap[36,69]
### this is for 20
meanmap[34,67]




meanmapRH = matrix(0,108,108)
for(i in 1:108){
    for(j in 1:108){
        meanmapRH[i,j] = mean(actmapRH[i:(i+19),j:(j+19)])
    }
}


image(meanmapRH)
rhmax = which.max(meanmapRH)
round(rhmax/108)+1
rhmax %% 108

### for 20: 75, 67




bigslices =  array(c(sliceLH,sliceRH), dim = c(128,128,24))

rfastresults.both = FASTfMRI(bigslices)

actmapboth = (rowMeans(rfastresults.both$ActMap, dims = 2))



meanmapboth = matrix(0,108,108)
for(i in 1:108){
    for(j in 1:108){
        meanmapboth[i,j] = mean(actmapboth[i:(i+19),j:(j+19)])
    }
}

image(meanmapboth)
rhmax = which.max(meanmapboth)
round(rhmax/108)+1
rhmax %% 108




biggroup = bigslices[34:53,67:86, ] # left
image(biggroup[,,8], axes = FALSE, col = gray(0:12/12))
image(biggroup[,,19], axes = FALSE, col = gray(0:12/12))

results = factor(rep(c('L','R'), each=12))
labels = results
######## final: do BIC for all combos

CSmodel <- matrixqda(biggroup[,,], labels, c(.5,.5),
                        method = 't', nu = 5,# repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "CS")
ARmodel <- matrixqda(biggroup[,,], labels, c(.5,.5),
                        method = 't', nu = 5, # repeat for normal, 10, 20 df
                     col.variance = "AR", row.variance = "AR")

CSARmodel <-  matrixqda(biggroup[,,], labels, c(.5,.5),
                        method = 't', nu = 5, # repeat for normal, 10, 20 df
                     col.variance = "CS", row.variance = "AR")

ARCSmodel <-  matrixqda(biggroup[,,], labels, c(.5,.5),
                        method = 't', nu = 5, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "CS")

UNConsmodel <- matrixqda(biggroup[,,], labels, c(.5,.5),
                        method = 't', nu = 5 # repeat for normal, 10, 20 df
                        )
BIC(logLik(CSmodel))
BIC(logLik(ARmodel))
BIC(logLik(CSARmodel))
BIC(logLik(ARCSmodel))
BIC(logLik(UNConsmodel))

### NU = 20

for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 20, # repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 20, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "AR"), 
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 20, # repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "AR"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 20, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 20, # repeat for normal, 10, 20 df
                    #    col.variance = "CS", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


### NU = 10

for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "AR"), 
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "AR"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 't', nu = 10, # repeat for normal, 10, 20 df
                    #    col.variance = "CS", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )

### NORMAL

for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 'normal', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 'normal', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "AR"), 
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )


for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 'normal', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "CS", row.variance = "AR"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 'normal', nu = 10, # repeat for normal, 10, 20 df
                        col.variance = "AR", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



for(obs in 1:24){
results[obs] <- (predict(matrixqda(biggroup[,,-obs], labels[-obs], c(.5,.5),
                        method = 'normal', nu = 10, # repeat for normal, 10, 20 df
                    #    col.variance = "CS", row.variance = "CS"), # repeat for CS as well
              newdata = biggroup[,,obs, drop = FALSE])$class)
}
sum(results == factor(rep(c('L','R'), each=12)) )



#### AR
### LH: [34:53,67:86, ]
### df 10 : 22
### df 20 : 23
### normal: 23

### RH: bigslices[75:94,67:86, ]
### df 10 : 17
### df 20 : 17
### normal: 17


#### CS
### LH: [34:53,67:86, ]
### df 10 : 23
### df 20 : 23
### normal: 23

### RH: bigslices[75:94,67:86, ]
### df 10 : 17
### df 20 : 18
### normal: 21


library('MatrixLDA')
lambda1.cv = 1
lambda2.cv = .5

X = biggroup
class = rep(c(1,2),each = 12)
X.test = X
class.test = class

#### This is commented out because it may blow up. Try at your own risk.

# out = MatLDA(X=X, class=class, lambda1=lambda1.cv,lambda2=lambda2.cv, quiet=FALSE,Xval=X.test, classval= class.test,k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)
