### Download relevant data from here:
### https://archive.ics.uci.edu/ml/datasets/Statlog+%28Landsat+Satellite%29
library('MixMatrix')
### specify the location of sat.trn and sat.tst if not downloaded into this
### folder, the data are not included in this zip file.

sat = read.csv('sat.trn', sep = " ", header = FALSE)
sattst = read.csv('sat.tst', sep = " ", header = FALSE)
arraysat = aperm(array(unlist(sat[,1:36]), dim = c(4435,4,9)), c(2,3,1))
arraytst = aperm(array(unlist(sattst[,1:36]), dim = c(2000,4,9)), c(2,3,1))
classes = sat[,37]
tstclasses = sattst[,37]
subset = arraysat[,,classes %in% c(3,4,5)]
subclasses = classes[classes %in% c(3,4,5)]
subtst = arraytst[,,tstclasses %in% c(3,4,5)]
subtstclass = tstclasses[tstclasses %in% c(3,4,5)]
#### looks like her paper trained and tested on the test set

prior <- table(subclasses)/length(subclasses)


UNcons <- matrixqda(subset, grouping = subclasses, prior = prior)

CSUNmodel <- matrixqda(subset, grouping = subclasses, prior = prior,
                       col.variance="CS", row.variance="UN")


ARARmodel <- matrixqda(subset, grouping = subclasses, prior = prior,
                       col.variance="AR", row.variance="AR")

CSCSmodel <- matrixqda(subset, grouping = subclasses, prior = prior,
                       col.variance="CS", row.variance="CS" )

ARCSmodel <- matrixqda(subset, grouping = subclasses, prior = prior,
                        col.variance="AR", row.variance="CS")

CSARmodel <- matrixqda(subset, grouping = subclasses, prior = prior,
                        col.variance="CS", row.variance="AR")

UNconsrow <- matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE)

CSUNrow <- matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE,
                       col.variance="CS", row.variance="UN")

ARARrow <- matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE,
                       col.variance="AR", row.variance="AR")

CSCSrow<- matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE,
                       col.variance="CS", row.variance="CS" )

ARCSrow<- matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE,
                        col.variance="AR", row.variance="CS")

CSARrow <- matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE,
                        col.variance="CS", row.variance="AR")


BIC(logLik(UNcons))
BIC(logLik(CSUNmodel))
BIC(logLik(ARARmodel))
BIC(logLik(CSCSmodel))
BIC(logLik(ARCSmodel))
BIC(logLik(CSARmodel))
BIC(logLik(UNconsrow))
BIC(logLik(CSUNrow))
BIC(logLik(CSCSrow))
BIC(logLik(ARCSrow))
BIC(logLik(CSARrow))



rescscsrow <- predict(UNconsrow,               newdata = subtst)

1-mean(rescscsrow$class == subtstclass)


res <- predict(matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE),
               newdata = subtst)

1-mean(res$class == subtstclass)


res.t10 <- predict(matrixqda(subset, grouping = subclasses, prior = prior, method = 't', row.mean = TRUE),
               newdata = subtst)

1-mean(res.t10$class == subtstclass)


res.t20 <- predict(matrixqda(subset, grouping = subclasses, prior = prior, method = 't', nu = 20, row.mean = TRUE),
               newdata = subtst)

1-mean(res.t20$class == subtstclass)



############## using UNCSrow just as an example
res <- predict(matrixqda(subset, grouping = subclasses, prior = prior, row.mean = TRUE,
                        col.variance="CS", row.variance="CS"),
               newdata = subtst)

1-mean(res$class == subtstclass)


res.t10 <- predict(matrixqda(subset, grouping = subclasses, prior = prior, method = 't', row.mean = TRUE,
                        col.variance="CS", row.variance="CS"),
               newdata = subtst)

1-mean(res.t10$class == subtstclass)


res.t20 <- predict(matrixqda(subset, grouping = subclasses, prior = prior, method = 't', nu = 20, row.mean = TRUE,
                        col.variance="CS", row.variance="CS"),
               newdata = subtst)

1-mean(res.t20$class == subtstclass)







### this gives warnings for some reason. not sure what is up.

#res.fixed <- predict(matrixqda(subset, grouping = subclasses, prior = c(1,1,1)/3,
#                               method = 't', fixed = FALSE, nu = 5, max.iter = 2),
#               newdata = subtst)
#
#1-mean(fixed.t10$class == subtstclass)

llvec = 1:100
for(i in 1:100){
    llvec[i] = logLik(matrixqda(subset, grouping = subclasses, prior = c(1,1,1)/3,
                               method = 't', fixed = TRUE, nu = i+2))
}
bestnu = which.max(llvec)+2

### looks like 10 is the best. 
